<template>
  <div class="login">
    <b-container>
      <b-row>
        <b-col>
          <h1>Login Page</h1>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <h3>Input your credentials</h3>
        </b-col>
        <b-col>
          <b-form @submit="onSubmit" @reset="onReset" v-if="show">
            <b-form-group
              id="input-group-username"
              label="Username:"
              label-for="input-username"
              description="We'll never share your username with anyone else"
            >
              <b-form-input
                id="input-username"
                v-model="form.username"
                type="text"
                placeholder="Enter username"
                required
              ></b-form-input>
            </b-form-group>
            <b-form-group
              id="input-group-password"
              label="Password:"
              label-for="input-password"
              description="We'll never share your password with anyone else"
            >
              <b-form-input
                id="input-password"
                v-model="form.password"
                type="password"
                placeholder="Enter password"
                required
              ></b-form-input>
            </b-form-group>
            <b-form-group id="input-group-remember">
              <b-form-checkbox v-model="form.remember" value="remember"
                >Remember me (not working)</b-form-checkbox
              >
            </b-form-group>

            <b-button type="submit" variant="dark">Submit</b-button>
            <b-button type="submit" variant="light">Reset</b-button>
          </b-form>
          <b-card class="mt-3" header="Form Data Result">
            <pre class="m-0">{{ form }}</pre>
          </b-card>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>
<script>
export default {
  data() {
    return {
      form: {
        username: "",
        password: "",
        remember: "",
      },
      show: true,
    };
  },
  methods: {
    onSubmit(event) {
      event.preventDefault();
      alert(JSON.stringify(this.form));
      if (this.form.password.length > 0) {
        this.$http
          .post("login_url", {
            username: this.form.username,
            password: this.form.password,
          })
          .then((response) => {
            // ...
            let is_admin = response.data.user.is_admin;
            localStorage.setItem("user", JSON.stringify(response.data.user));
            localStorage.setItem("jwt", response.data.token);

            if (localStorage.getItem("jwt") != null) {
              this.$emit("loggedIn");
              if (this.$route.params.nextUrl != null) {
                this.$router.push(this.$route.params.nextUrl);
              } else if (is_admin == 1) {
                this.$router.push("admin");
              } else {
                this.$router.push("dashboard");
              }
            }
          })
          .catch((error) => {
            console.error(error.response);
          });
      }
    },
    onReset(event) {
      event.preventDefault();
      this.form.username = "";
      this.form.password = "";
      this.form.remember = false;
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    },
  },
};
</script>
